:: This script copy contents of minimal_linux_live.iso file
:: that is located in the same directory with the script,
:: to specified in runtime flashstorage.
::
:: Demand in the same directory:
:: 1)7z.exe --- archiver
:: 2)syslinux.exe --- bootloader installer

@echo off
pushd %~dp0
set isusb=no
set usbfound=no

if not exist "%cd%\minimal_linux_live.iso" (
    echo Unable to found minimal_linux_live.iso in current directory.
    goto FORCE_EXIT
) 

for /F "usebackq tokens=1,2,3,4 " %%i in (`wmic logicaldisk get caption^,description^,drivetype 2^>NUL`) do (
    if %%l equ 2 (
        set usbfound=yes
    )
)

if /i not "%usbfound%" == "yes" (
    echo Unable to find USB Flash Storage.
    goto FORCE_EXIT
)

echo | set /p=Available USB: 
for /F "usebackq tokens=1,2,3,4 " %%i in (`wmic logicaldisk get caption^,description^,drivetype 2^>NUL`) do (
    if %%l equ 2 (
        echo | set /p=%%i 
        set usbfound=yes
    )
)
    
echo.   

set /p Disk=  Select Disk (Ltr): 

for /F "usebackq" %%i in (`wmic logicaldisk %Disk%: get drivetype 2^>NUL`) do (
    if %%i equ 2 (
        set isusb=yes
    )
)

if /i not "%isusb%" == "yes" (
    echo Disk %Disk% is not USB Flash
    goto FORCE_EXIT
)

set /p response=  All data on disk %Disk%: will be lost. Continue (yes/no)? 

if /i "%Disk%" == "C" (
    goto FORCE_EXIT
)

if /i not "%response%" == "yes" (
    if /i not "%response%" == "y" (
        goto FORCE_EXIT
    )
)

echo select volume %Disk% > "%cd%\script.txt"
echo clean >> "%cd%\script.txt"
echo create partition primary >> "%cd%\script.txt"
echo select partition 1 >> "%cd%\script.txt"
echo active >> "%cd%\script.txt"
echo format fs=fat32 quick label=FlashTool >> "%cd%\script.txt"
echo assign letter=%Disk% >> "%cd%\script.txt"
echo exit >> "%cd%\script.txt"

echo Formating disk %Disk%.
diskpart /s "%cd%\script.txt"

if /i not "%ERRORLEVEL%"=="0" (
    echo FAIL!
    goto FORCE_EXIT
)

echo Copy OS data.
7z -o%Disk%:\ e minimal_linux_live.iso >> "%cd%\script.txt"

if /i not "%ERRORLEVEL%"=="0" (
    echo FAIL!
    goto FORCE_EXIT
)

rename %Disk%:\isolinux.cfg syslinux.cfg
if /i not "%ERRORLEVEL%"=="0" (
    echo FAIL!
    goto FORCE_EXIT
)

echo Installing bootloader.

syslinux.exe -m -a -d / %Disk%:

if /i not "%ERRORLEVEL%"=="0" (
    echo FAIL!
    goto FORCE_EXIT
)

if /I "%1" == "-e" (
    mkdir %Disk%:\eraselist
    xcopy /z "%~2" %Disk%:\eraselist\
    if /i not "%ERRORLEVEL%"=="0" (
        echo FAIL!
        goto FORCE_EXIT
    )
)

if /I "%1" == "-f" (
    mkdir %Disk%:\fwimages  
    if /I "%~2" == "-r" (
       copy /z "%~3" %Disk%:\fwimages\fwrevision 
    ) 
)


echo Cleaning.

del "%cd%\script.txt" /q

del %Disk%:\Boot-NoEmul.img

del %Disk%:\isolinux.bin

del %Disk%:\boot.cat



if /I "%1"=="" goto SUCCESS_EXIT

:SUCCESS_EXIT

echo Bootable USB with Linux was successfully created.


if /I "%3" == "-s" (


     echo.

     echo The following devices %~4 are ready to be erased.

     echo.


)


echo To proceed with secure erase, you need to boot from USB drive.

set /p reboot= "Do you want to reboot now (yes/no)? "

if /i "%reboot%" == "yes" (

    shutdown.exe /r /t 00

)

if /i "%reboot%" == "y" (

    shutdown.exe /r /t 00

)

:FORCE_EXIT

echo Exiting...

Exit /B
